------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.                              --
--  License text and authors contact information could be found in oci.ads  --
------------------------------------------------------------------------------
with OCI.Thread;
package body OCI.Thick.Description is

   ------------
   -- Create --
   ------------

   function Create (Connect : Connection; Name : String) return Describe is
      Result : Describe;
      rc : sword := OCIDESCRIBEANY(svchp => OCISVCCTX(Connect.Handle),
                            errhp     => Thread.Error,
                            objptr    => Name'Address,
                            objnm_len => Name'Length,
                            objptr_typ=> OCI_OTYPE_NAME,
                            info_level=> OCI_DEFAULT,
                            objtyp    => OCI_PTYPE_UNK,
                            dschp     => OCIDESCRIBE(Result.Handle));
   begin
      Check_Error(rc);
      return Result;
   end Create;

   -------------
   -- Destroy --
   -------------

   procedure Destroy (Object : in out Describe) is
   begin
      Free(Object.Handle,OCI_HTYPE_DESCRIBE);
   end Destroy;

   ----------------
   -- Initialize --
   ----------------

   procedure Initialize (Object : in out Describe) is
   begin
     Object.Handle := Alloc_Handle(Thread.Environment,OCI_HTYPE_DESCRIBE);
   end Initialize;

   ------------------
   -- Integer_Attr --
   ------------------

   function Get_Attr (Desc : Describe; Attr : Attribute) return Integer
   is
   begin
      return Get_Attr(Desc.Handle, OCI_HTYPE_DESCRIBE, ub4(Attr));
   end Get_Attr;

   -----------------
   -- String_Attr --
   -----------------

   function Get_Attr (Desc : Describe; Attr : Attribute) return String is
   begin
      return Get_Attr (Desc.Handle, OCI_HTYPE_DESCRIBE, ub4(Attr));
   end Get_Attr;

end OCI.Thick.Description;

