------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.                              --
--  License text and authors contact information could be found in oci.ads  --
------------------------------------------------------------------------------
with OCI.Thick.Statements;

generic
   type Variable_Type is private;
package OCI.Thick.Variable is

   use OCI.Thick.Statements;

   type Var_Type (Type_Id : ub2) is new Limited_Variable with private;
      
   procedure Bind (Stmt : Statement; Value : in out Var_Type; Name : String);
   procedure Bind (Stmt : Statement; Value : in out Var_Type; Position : Positive);
      
   procedure Define(Stmt : Statement; Value : in out Var_Type; Position : Positive);
   procedure Set_Value(Var : in out Var_Type; Value : Variable_Type);
   function Get_Value(Var : Var_Type) return Variable_Type;
   function Value(Var : Var_Type) return Variable_Type renames Get_Value;
   function Get_Value_Internal(Var : Var_Type) return Variable_Type;

private

   pragma inline (Get_Value_Internal);

   type Var_Type(Type_Id : ub2) is 
   new Limited_Variable with record
      Value : Variable_Type;
   end record;

end OCI.Thick.Variable;