with Subscriber;
with OCI.Thick.Connections;

with Ada.Exceptions;
with GNAT.Traceback.Symbolic;
with OCI.Thick.Notifications;

with Ada.Text_IO;
procedure Subscr is
   use OCI.Thick.Connections;
   use Subscriber;
   use Ada.Text_IO;
   Connect : Connection;
   Consumer : Subscriber_Type;
begin
   OCI.Thick.Set_Events_Support;
   Put_Line ("=========");
   Connect := Logon ("scott/tiger");

   Create (Consumer, "test_subscr_notification",
      OCI.Thick.Notifications.Anonymous);
       
   Register (Consumer, Connect);

   Enable (Consumer);

   loop

      declare
         Line : String (1 .. 80);
         Last : Natural;
      begin
         Put ('>');
         Get_Line (Line, Last);
         Post (Consumer, Connect, Line (1 .. Last));
         exit when Line (1 .. Last) = "exit";
      end;

   end loop;

exception
   when E : others =>
      Put_Line(Ada.Exceptions.Exception_Information(E));
      Put_Line("----------");
      Put_Line(GNAT.Traceback.Symbolic.Symbolic_Traceback(E));
end;