#include "ociap.h"
#include <stdlib.h>

OCIError *errhp;  /* the error handle */
OCIEnv *envhp; /* the environment handle */

char * username = "scott";
char * password = "tiger";
char * dbname = "";

char * stmt_text = "begin null; end;";

int memory_counter = 0;

void checkerr (sword status)
{ text errbuf[512];
  ub4 buflen;
  ub4 errcode;
switch (status)
{ case OCI_SUCCESS:
    break;
  case OCI_ERROR:
    OCIErrorGet ((dvoid *) errhp, (ub4) 1, (text *) NULL, &errcode,
            errbuf, (ub4) sizeof(errbuf), (ub4) OCI_HTYPE_ERROR);
    printf("Error %s\n", errbuf);
    break;
  default:
    printf("Error %d\n", status);
  }
}

dvoid * mem_alloc (dvoid *ctxp, size_t size) {
    memory_counter++;
    printf ("alloc %d = 0x%x\n", size, size);
    return malloc (size);
    };

dvoid   * mem_realloc (dvoid *ctxp, 
     dvoid *memptr, size_t newsize) {
    printf ("realloc %d\n", newsize);
    if (newsize = 0)
       memory_counter--;
    return realloc (memptr, newsize);
};

void    mem_free (dvoid *ctxp,
              dvoid *memptr) {
       printf ("free\n");
       memory_counter--;
       free (memptr);      	
       };

int main() {

        OCISvcCtx * svchp1;
        OCISvcCtx * svchp2;
        OCIStmt * stmtp;
        int loop_counter = 0;
        int prev_loop_counter = 0;
        
        puts ("Environment");
	OCIEnvCreate (&envhp, OCI_THREADED | OCI_OBJECT, (dvoid *)0, 
                               &mem_alloc, &mem_realloc, &mem_free,
                       0, (dvoid **)0);
                       
        puts ("Error handle");
	OCIHandleAlloc ( (dvoid *) envhp, (dvoid **) &errhp,
	      OCI_HTYPE_ERROR, 0, (dvoid **) 0);

	puts ("Logon 1");
	
	checkerr (
        OCILogon (envhp, errhp,
                     &svchp1,
                    username,
                    strlen (username),
                    password,
                    strlen (password),
                    dbname,
                    strlen (dbname)));	
                    
	puts ("Logon 2");
	
	checkerr (
        OCILogon (envhp, errhp,
                     &svchp2,
                    username,
                    strlen (username),
                    password,
                    strlen (password),
                    dbname,
                    strlen (dbname)));	
        
	puts ("Statement");
	
	OCIHandleAlloc ( (dvoid *) envhp, (dvoid **) &stmtp,
	      OCI_HTYPE_STMT, 0, (dvoid **) 0);
	      
	puts ("Prepare");
        checkerr (  OCIStmtPrepare (stmtp,
           errhp,
           stmt_text, 
           strlen (stmt_text),
           OCI_NTV_SYNTAX,
           OCI_DEFAULT));
           
       for (;;loop_counter++) {
       	  

       	 int prev_memory_counter = memory_counter;
       	 
       	 sword state;
       	
             state = OCIStmtExecute (svchp1,
                       stmtp,
                       errhp,
                       1,
                       0,
                       (OCISnapshot   *) 0,
                       (OCISnapshot   *) 0,
                        OCI_DEFAULT);
                       
       	 if (state != OCI_SUCCESS) {
             checkerr (state);
             return 1;
         };

                       
         state = OCIStmtExecute (svchp2,
                       stmtp,
                       errhp,
                       1,
                       0,
                       (OCISnapshot   *) 0,
                       (OCISnapshot   *) 0,
                        OCI_DEFAULT);
                       
       	 if (state != OCI_SUCCESS) {
             checkerr (state);
             return 1;
         };

         
         if (prev_memory_counter != memory_counter) {
             printf ("Memory counter %d -> %d via %d iterations\n", 
             	prev_memory_counter, memory_counter,
             	 loop_counter - prev_loop_counter);
             prev_memory_counter = memory_counter;
             prev_loop_counter = loop_counter;
             if (prev_memory_counter > memory_counter)
               return 0;
         }
                       
       	}
        
	return 0;
	};