------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.                              --
--  License text and authors contact information could be found in oci.ads  --
------------------------------------------------------------------------------
with
   Text_IO,
   Oci.Thick.Connections,
   Oci.Thick.Statements,
   OCI.Thick.Strings,
   Oci.Thick.Binds.Lob,
   Oci.Thick.Lobs;

with Ada.Exceptions;
with GNAT.Traceback.Symbolic;

procedure Test_Lob is
   use
      Text_IO,
      Oci.Thick;
      
   use
      Connections,
      Strings,
      Statements,
      Binds.Lob,
      Lobs;

   Connect : Connection := Logon("scott/tiger");
   -- Loc : Lob := Create_Temporary (Connect);
   Loc : Lob := Create_Empty (Connect);
   Bind1, Bind2 : Bind_Lob;
   Buffout : String (1 .. 79) := (others => '_');
     Stmt1, Stmt2 : Statement;
   offset : Lobs.Count := 1;  
   Str : Variable;
   amt : Lobs.Count;  
   sum_amt : Lobs.Count := 0;  
   
   procedure Output_CLob
   is
   begin
      loop
        Read (Loc, amt, offset, Buffout);
        Put_Line (Buffout);
        Buffout := (others => buffout (buffout'First));
   --     Write(Loc,offset,Buffout);
        offset := offset+amt+1;
        sum_amt := sum_amt+amt;
   --     exit;
        exit when amt < Buffout'Length;
      end loop;
   end;


begin
   Stmt1 := Prepare(Connect,
      "begin "&
       "  DBMS_LOB.createtemporary (:lob, true);"&
       "  DBMS_LOB.trim (:lob,0);"&
      "  for i in 1..000 loop "&
      "   DBMS_LOB.WRITEAPPEND (:lob, 4, lpad(i,4));"&
      "  end loop; "&
      "end;");

   Stmt2 := Prepare(Connect,
      "begin "&
      "  for i in 1..20 loop "&
      "     DBMS_LOB.WRITEAPPEND (:lob,3,lpad (i,3));"&
      "  end loop; "&
      "end;");

   Put_Line("Prepared");
   
   Bind (Stmt1, Bind1, Loc, ":lob");
   Bind (Stmt2, Bind2, Loc, ":lob");

   Put_Line("Binded");
   
   if Is_Init (Loc) then
      Put_Line("init");
   else
      Put_Line("not initialized");
   end if;
   
   Execute (Stmt1);
   Put_Line("Executed1");
   Output_Clob;
   
   Execute(Stmt2);
   Output_Clob;
   
   Put_Line("Executed2");

   Put_Line("readed " & Lobs.Count'Image (sum_amt) & Boolean'Image (Is_Init (Loc)));
--   Put_Line(To_String(Loc));
   Free_Temporary (Loc);
   Put_Line("end "&Boolean'Image(Is_Init(Loc)));
exception
      when e: others =>
      
         Put_Line (Standard_Error, Ada.Exceptions.Exception_Information (E));
         Put_Line (Standard_Error, GNAT.Traceback.Symbolic.Symbolic_Traceback (E));

end;